=== extensions/postgis_tiger_geocoder/Makefile ===
include ../upgradeable_versions.mk

EXTENSION    = postgis_tiger_geocoder
EXTVERSION    = 2.2.1
MINORVERSION  = 2011.2.2
GREP = /bin/grep

MICRO_NUMBER  = $(shell echo $(EXTVERSION) | sed "s/[0-9]\.[0-9]\.\([0-9]*\)[a-zA-Z]*[0-9]*/\1/")
PREREL_NUMBER = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/[0-9][a-zA-Z]\([0-9]*\)[a-zA-Z]*/\1/")
MICRO_PREV    = $(shell if test "$(MICRO_NUMBER)x" != "x"; then expr $(MICRO_NUMBER) - 1; fi)
PREREL_PREV   = $(shell if test "$(PREREL_NUMBER)x" != "x"; then expr $(PREREL_NUMBER) - 1; fi)

PREREL_PREFIX = $(shell echo $(EXTVERSION) | \
                        sed "s/[0-9]\.[0-9]\.\(.*\)/\1/" | \
                        $(GREP) "[a-zA-Z]" | \
                        sed "s/\([0-9][a-zA-Z]*\)[0-9]*/\1/")

DATA         = $(filter-out $(wildcard sql/*--*.sql),$(wildcard sql/*.sql))
REGRESS = test-normalize_address
REGRESS_OPTS = --load-extension=fuzzystrmatch --load-extension=postgis --load-extension=$(EXTENSION)

PG_CONFIG    =  /var/lib/jenkins/workspace/pg/rel/pg9.3w64/bin/pg_config

PG91         = $(shell $(PG_CONFIG) --version | $(GREP) -qE " 8\.| 9\.0" && echo no || echo yes)
SQL_BITS     = $(wildcard sql_bits/*.sql)
EXTRA_CLEAN += sql/*.sql ${SQL_BITS} 

#test address standardizer if also built
ifeq (address_standardizer,address_standardizer)
	REGRESS +=  test-pagc_normalize_address
	REGRESS_OPTS += --load-extension=address_standardizer
endif

ifeq ($(PG91),yes)
all: sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql  sql_minor_upgrade sql/test-normalize_address.sql  sql/test-pagc_normalize_address.sql expected/test-normalize_address.out expected/test-pagc_normalize_address.out sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql  sql_minor_upgrade

sql/$(EXTENSION)--$(EXTVERSION).sql: sql/$(EXTENSION).sql
	mkdir -p sql
	mkdir -p expected
	cp $< $@


expected/test-normalize_address.out: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/normalize_address_regress
	cat $^ > $@
	
expected/test-pagc_normalize_address.out: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/pagc_normalize_address_regress
	cat $^ > $@
	
## adding \t .. to force output to be the same as what get in regular regress in tiger folder
sql/test-normalize_address.sql: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/normalize_address_regress.sql
	mkdir -p sql
	cat $^ > $@
	
sql/test-pagc_normalize_address.sql: sql_bits/test_tuples_only_unaligned.sql.in ../../extras/tiger_geocoder/regress/pagc_normalize_address_regress.sql
	mkdir -p sql
	cat $^ > $@
	
sql/$(EXTENSION).sql: sql_bits/tiger_geocoder.sql  sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql
	mkdir -p sql
	cat $^ > $@
	
#this is a cludge to allow upgrading from same SVN to same SVN
sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/tiger_geocoder_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql ../postgis_extension_helper_uninstall.sql
	mkdir -p sql
	cat $^ > $@


sql/$(EXTENSION)--$(EXTVERSION)next--$(EXTVERSION).sql: sql/$(EXTENSION)--$(EXTVERSION)--$(EXTVERSION)next.sql
	mkdir -p sql
	cp $< $@
	
#strip BEGIN/COMMIT since these are not allowed in extensions
#strip CREATE SCHEMA since we force extension 
# to create schema by setting schema to tiger_geocoder in control
sql_bits/tiger_geocoder_minor.sql.in: ../../extras/tiger_geocoder/utility/set_search_path.sql \
  	../../extras/tiger_geocoder/geocode_settings.sql \
  ../../extras/tiger_geocoder/tiger_loader_2015.sql \
	../../extras/tiger_geocoder/utility/utmzone.sql \
	../../extras/tiger_geocoder/utility/cull_null.sql \
	../../extras/tiger_geocoder/utility/nullable_levenshtein.sql \
	../../extras/tiger_geocoder/utility/levenshtein_ignore_case.sql \
	../../extras/tiger_geocoder/normalize/end_soundex.sql \
	../../extras/tiger_geocoder/normalize/count_words.sql \
	../../extras/tiger_geocoder/normalize/state_extract.sql \
	../../extras/tiger_geocoder/normalize/get_last_words.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract.sql \
	../../extras/tiger_geocoder/normalize/normalize_address.sql \
	../../extras/tiger_geocoder/normalize/pprint_addy.sql \
	../../extras/tiger_geocoder/pagc_normalize/pagc_tables.sql \
  ../../extras/tiger_geocoder/pagc_normalize/pagc_normalize_address.sql \
	../../extras/tiger_geocoder/geocode/other_helper_functions.sql \
	../../extras/tiger_geocoder/geocode/rate_attributes.sql \
	../../extras/tiger_geocoder/geocode/includes_address.sql \
	../../extras/tiger_geocoder/geocode/interpolate_from_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_location.sql \
	../../extras/tiger_geocoder/geocode/geocode_intersection.sql \
	../../extras/tiger_geocoder/geocode/geocode.sql \
	../../extras/tiger_geocoder/geocode/reverse_geocode.sql \
	../../extras/tiger_geocoder/geocode/census_tracts_functions.sql
	cat $^ > $@
	
sql_bits/tiger_geocoder.sql.in: sql_bits/norm_addy_create.sql.in \
	../../extras/tiger_geocoder/utility/set_search_path.sql \
	../../extras/tiger_geocoder/geocode_settings.sql \
	../../extras/tiger_geocoder/tables/lookup_tables_2011.sql \
	../../extras/tiger_geocoder/tiger_loader_2015.sql \
	../../extras/tiger_geocoder/utility/set_search_path.sql \
	../../extras/tiger_geocoder/utility/utmzone.sql \
	../../extras/tiger_geocoder/utility/cull_null.sql \
	../../extras/tiger_geocoder/utility/nullable_levenshtein.sql \
	../../extras/tiger_geocoder/utility/levenshtein_ignore_case.sql \
	../../extras/tiger_geocoder/normalize/end_soundex.sql \
	../../extras/tiger_geocoder/normalize/count_words.sql \
	../../extras/tiger_geocoder/normalize/state_extract.sql \
	../../extras/tiger_geocoder/normalize/get_last_words.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_countysub_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_exact.sql \
	../../extras/tiger_geocoder/normalize/location_extract_place_fuzzy.sql \
	../../extras/tiger_geocoder/normalize/location_extract.sql \
	../../extras/tiger_geocoder/normalize/normalize_address.sql \
	../../extras/tiger_geocoder/normalize/pprint_addy.sql \
	../../extras/tiger_geocoder/pagc_normalize/pagc_tables.sql \
    ../../extras/tiger_geocoder/pagc_normalize/pagc_normalize_address.sql \
	../../extras/tiger_geocoder/geocode/other_helper_functions.sql \
	../../extras/tiger_geocoder/geocode/rate_attributes.sql \
	../../extras/tiger_geocoder/geocode/includes_address.sql \
	../../extras/tiger_geocoder/geocode/interpolate_from_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_address.sql \
	../../extras/tiger_geocoder/geocode/geocode_location.sql \
	../../extras/tiger_geocoder/geocode/geocode_intersection.sql \
	../../extras/tiger_geocoder/geocode/geocode.sql \
	../../extras/tiger_geocoder/geocode/reverse_geocode.sql \
	../../extras/tiger_geocoder/geocode/census_tracts_functions.sql \
	../../extras/tiger_geocoder/topology/tiger_topology_loader.sql \
	../postgis_extension_helper.sql \
	sql_bits/add_search_path.sql \
	../postgis_extension_helper_uninstall.sql 
	cat $^ > $@
	
sql_bits/tiger_geocoder.sql: sql_bits/tiger_geocoder.sql.in
	sed -e 's/BEGIN;//g' -e 's/COMMIT;//g' -e '/^CREATE SCHEMA/d;'  $< > $@
	
sql_bits/add_search_path.sql: sql_bits/add_search_path.sql.in
	cp $< $@
	
../../doc/tiger_geocoder_comments.sql:
	$(MAKE) -C ../../doc comments
	
sql_bits/tiger_geocoder_comments.sql: ../../doc/tiger_geocoder_comments.sql
	cp $< $@
	
#grep all lines that start with CREATE OR REPLACE FUNCTION, TRIGGER...
#then replace CREATE OR REPLACE .. with ALTER EXTENSION..;
#then remove default values and extra junk
# sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: ../../tiger_geocoder/tiger_geocoder.sql
# 	sed -e '/^CREATE \(OR REPLACE\|TYPE\|TABLE\|VIEW\|CAST\)/!d;' \
# 		-e 's/OR REPLACE//g' \
# 		-e 's/CREATE\(.*\)/ALTER EXTENSION $(EXTENSION) ADD\1;/' \
# 		-e 's/DEFAULT [\.0-9a-zA-Z]\+//g' \
# 		-e 's/\(BEFORE\|WITH FUNCTION\)\(.*\)/;/' \
# 		-e 's/[ \t]+;/;/' \
# 		-e 's/(;/;/' \
# 		-e 's/\\(;/;/' \
# 		-e 's/;;/;/g' $< > $@

#hardcode for now using 
#the extensions/make_unpackaged.sql script form an install
sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql: sql_bits/tiger_geocoder--unpackaged.sql.in
	mkdir -p sql
	cp $< $@

#upgrade script should have everything but table, schema, type creation/alter
#NOTE: we assume all object definitions end in ;
#first expression deletes all non-removable objects defined on same line
#second deletes all non-removable defined on multiple lines 
#  the end of the body of object we assume ends in ;
#aggregates are special 
#they can be dropped but we need to remove
#them from the extension first
sql/tiger_geocoder_upgrade_minor.sql:  sql_bits/tiger_geocoder_minor.sql.in 
	mkdir -p sql
	 sed -e '/^\(CREATE\|ALTER\) \(CAST\|TYPE\|TABLE\|SCHEMA\|DOMAIN\|TRIGGER\).*;/d' \
	 	 -e '/^\(CREATE\|ALTER\) \(CAST\|TYPE\|TABLE\|SCHEMA\|DOMAIN\|TRIGGER\)/,/\;/d' \
	 	 -e 's/BEGIN;//g' -e 's/COMMIT;//g' \
	 	 $< > $@
	 	 	
sql_minor_upgrade: ../postgis_extension_helper.sql sql_bits/remove_from_extension.sql.in sql/tiger_geocoder_upgrade_minor.sql sql_bits/mark_editable_objects.sql.in sql_bits/tiger_geocoder_comments.sql ../postgis_extension_helper_uninstall.sql
	for OLD_VERSION in $(UPGRADEABLE_VERSIONS); do \
  	  cat $^ > sql/$(EXTENSION)--$$OLD_VERSION--$(EXTVERSION).sql; \
	done

#only extension files	
DATA = ${EXTENSION}.control sql/$(EXTENSION).sql $(wildcard sql/*--*.sql)
EXTRA_CLEAN += $(wildcard expected/*--*.out)
EXTRA_CLEAN += sql/$(EXTENSION)--$(EXTVERSION).sql sql/$(EXTENSION)--unpackaged--$(EXTVERSION).sql
endif

distclean: clean
	rm Makefile

PGXS := $(shell $(PG_CONFIG) --pgxs)
include $(PGXS)
