=== doc/po/it_IT/Makefile ===
DOCSUFFIX=-it
include ../Makefile.local
