=== doc/po/pl/Makefile ===
DOCSUFFIX=-pl
include ../Makefile.local
