=== debian/changelog ===
postgis (2.2.1+dfsg-2ubuntu0.1) xenial-security; urgency=medium

  * SECURITY UPDATE: An empty argument in a postgis function can cause a DoS
    in PostgreSQL. This fix avoid it.
    - debian/patches/CVE-2017-18359.patch: ST_AsX3D handle empty geometries.
    - CVE-2017-18359

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Wed, 13 Feb 2019 12:07:43 -0200
